/*
 * Project: MoreOptions
 * File: FormOptions.prg
 * Description: Editor extra options
 * Author: Jose Lalin
 * Date:
 */

#include "Xailer.ch"

#define SCWS_INVISIBLE           0
#define SCWS_VISIBLEALWAYS       1
#define SCWS_VISIBLEAFTERINDENT  2

#define SC_EOL_CRLF        0
#define SC_EOL_CR          1
#define SC_EOL_LF          2
#define SCI_CONVERTEOLS    2029

#define SCI_SETCARETWIDTH 2188
#define SCI_GETCARETWIDTH 2189

#define SCI_STYLESETBACK 2052
#define SCI_STYLEGETBACK 2482

#define SCI_GETCARETSTYLE 2513
#define SCI_SETMULTIPLESELECTION 2563
#define SCI_GETMULTIPLESELECTION 2564
#define SCI_SETADDITIONALSELECTIONTYPING 2565
#define SCI_GETADDITIONALSELECTIONTYPING 2566

#define SCI_SETMULTIPASTE 2614
#define SCI_GETMULTIPASTE 2615

#define STYLE_BRACELIGHT 34

#define CARETSTYLE_LINE    1
#define CARETSTYLE_BLOCK   2

#define SCI_SETEXTRAASCENT 2525
#define SCI_GETEXTRAASCENT 2526
#define SCI_SETEXTRADESCENT 2527
#define SCI_GETEXTRADESCENT 2528

#define SC_WRAP_NONE 0
#define SC_WRAP_WORD 1
#define SC_WRAP_CHAR 2
#define SC_WRAP_WHITESPACE 3
#define SCI_SETWRAPMODE 2268
#define SCI_GETWRAPMODE 2269
#define SC_WRAPVISUALFLAG_NONE 0x0000
#define SC_WRAPVISUALFLAG_END 0x0001
#define SC_WRAPVISUALFLAG_START 0x0002
#define SC_WRAPVISUALFLAG_MARGIN 0x0004
#define SCI_SETWRAPVISUALFLAGS 2460
#define SCI_GETWRAPVISUALFLAGS 2461
#define SC_WRAPVISUALFLAGLOC_DEFAULT 0x0000
#define SC_WRAPVISUALFLAGLOC_END_BY_TEXT 0x0001
#define SC_WRAPVISUALFLAGLOC_START_BY_TEXT 0x0002
#define SCI_SETWRAPVISUALFLAGSLOCATION 2462
#define SCI_GETWRAPVISUALFLAGSLOCATION 2463
#define SCI_SETWRAPSTARTINDENT 2464
#define SCI_GETWRAPSTARTINDENT 2465
#define SC_WRAPINDENT_FIXED 0
#define SC_WRAPINDENT_SAME 1
#define SC_WRAPINDENT_INDENT 2
#define SCI_SETWRAPINDENTMODE 2472
#define SCI_GETWRAPINDENTMODE 2473

//------------------------------------------------------------------------------

CLASS TFormOptions FROM TForm

   COMPONENT oGroupFold
   COMPONENT oRadioMenuFold
   COMPONENT oGroupBoxWS
   COMPONENT oRadioMenuWS
   COMPONENT oCheckboxEOL
   COMPONENT oGroupCaret
   COMPONENT oLabelCaret
   COMPONENT oComboCaret
   COMPONENT oLabelColor
   COMPONENT oGroupBrace
   COMPONENT oCheckboxAuto
   COMPONENT oLabelBkColor
   COMPONENT oGroupMenu
   COMPONENT oRadioMenuMenu
   COMPONENT oGroupAsc
   COMPONENT oPanel1
   COMPONENT oBtnCancel
   COMPONENT oBtnApply
   COMPONENT oBtnOk
   COMPONENT oEditAsc
   COMPONENT oLabel1
   COMPONENT oLabel2
   COMPONENT oEditDes
   COMPONENT oGroupCase
   COMPONENT oRadioCase
   COMPONENT oGroupWrap
   COMPONENT oRadioWrap
   COMPONENT oGroupWrapOptions
   COMPONENT oLabelVisual
   COMPONENT oComboVisual
   COMPONENT oLabelLocation
   COMPONENT oComboLocation
   COMPONENT oLabelIndentMode
   COMPONENT oComboIndentMode
   COMPONENT oLabelStartIndent
   COMPONENT oEditStartIndent
   COMPONENT oGroupSel
   COMPONENT oCheckMultiSel
   COMPONENT oCheckType
   COMPONENT oCheckMultiPaste

   DATA oPlugin
   DATA IEditor
   DATA IMenu
   DATA nLang

   METHOD CreateForm()
   METHOD Label2Click( oSender )
   METHOD FormInitialize( oSender )
   METHOD LabelColorClick( oSender )
   METHOD Button2Click( oSender )
   METHOD Button1Click( oSender )
   METHOD RadioWrapChange( oSender, nIndex, nOldIndex )

ENDCLASS

#include "FormOptions.xfm"

//------------------------------------------------------------------------------

METHOD Label2Click( oSender ) CLASS TFormOptions

   WITH OBJECT TChooseColorDlg():Create()
      :nColor := ::IEditor:SendMsg( SCI_STYLEGETBACK, STYLE_BRACELIGHT )
      :lCenter := .T.
      IF :Run()
         oSender:nClrPane := :nColor
      ENDIF
   END

RETURN Nil

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TFormOptions

   IF ::nLang == 3 .OR. ::nLang == 10 .OR. ::nLang == 45 .OR. ::nLang == 86
      ::oGroupFold:cText := "Plegado de cdigo"
      ::oRadioMenuFold:aItems := { "Cuadrado", "Crculo", "Simple", "Flecha", "Ninguno" }
      ::oGroupBoxWS:cText := "Ver espacios"
      ::oRadioMenuWS:aItems := { "Nunca", "Siempre", "Tras indentado" }
      ::oGroupMenu:cText := "Estilo de men"
      ::oRadioMenuMenu:aItems[1] := "Por defecto"
      ::oCheckboxEOL:cText := "Ver caracter EOL"
      ::oGroupCaret:cText := "Cursor"
      ::oLabelCaret:cText := "Ancho"
      ::oComboCaret:ModifyItem( 4, "Bloque" )
      ::oGroupBrace:cText := "Parntesis"
      ::oCheckboxAuto:cText := "Autocompletar ([{<"
      ::oLabelBkColor:cText := "Color de fondo"
      ::oBtnOk:cText := "Aceptar"
      ::oBtnApply:cText := "Aplicar"
      ::oBtnCancel:cText := "Cancelar"
      ::oGroupAsc:cText := "Interlineado"
      ::oEditAsc:cText := "Superior"
      ::oEditDes:cText := "Inferior"
      ::oGroupCase:cText := "Auto convertir"
      ::oRadioCase:aItems := { "Ninguno", "Maysculas", "Minsculas", "Maysculas real", "Minsculas real" }

      ::oGroupWrap:cText := "Ajuste de lnea"
      ::oRadioWrap:aItems := { "Ninguno", "Carcter", "Palabra", "Espacio" }
      ::oGroupWrapOptions:cText := "Opciones de visualizacin"
      ::oLabelVisual:cText := "Marcas"
      ::oComboVisual:aItems := { "Ninguno", "Inicio de lnea", "Fin de lnea", "Margen" }
      ::oLabelLocation:cText := "Posicin"
      ::oComboLocation:aItems := { "Por defecto", "Inicio", "Final" }
      ::oLabelIndentMode:cText := "Sangrado"
      ::oComboIndentMode:aItems := { "Fijo", "Igual", "Indentado" }
      ::oLabelStartIndent:cText := "Sangrar a"

      ::oGroupSel:cText := "Multi seleccin"
      ::oCheckMultiSel:cText := "Activar"
      ::oCheckType:cText := "Permitir escritura"
      ::oCheckMultiPaste:cText := "Multi pegado"
   ENDIF

   IF ::IEditor:lFolding
      ::oRadioMenuFold:nIndex := ::IEditor:nFoldStyle + 1
   ELSE
      ::oRadioMenuFold:nIndex := 5
   ENDIF

   ::oRadioMenuWS:nIndex := ::IEditor:nViewWhiteSpace + 1
   ::oCheckboxEOL:lChecked := ::IEditor:lViewEOL

   ::oRadioMenuMenu:nIndex := ::IMenu:nStyle + 1

   IF ::IEditor:nCaretStyle == CARETSTYLE_LINE
      ::oComboCaret:nIndex := ::IEditor:SendMsg( SCI_GETCARETWIDTH )
   ELSE
      ::oComboCaret:nIndex := 4
   ENDIF

   ::oLabelColor:nClrPane := ::IEditor:nCaretClrFore

   ::oCheckboxAuto:lChecked := ::IEditor:lCompleteBraces
   ::oLabelBkColor:nClrPane := ::IEditor:SendMsg( SCI_STYLEGETBACK, STYLE_BRACELIGHT )

   ::oEditAsc:Value := LTrim( Str( ::IEditor:SendMsg( SCI_GETEXTRAASCENT ) ) )
   ::oEditDes:Value := LTrim( Str( ::IEditor:SendMsg( SCI_GETEXTRADESCENT ) ) )

   ::oRadioCase:nIndex := ::IEditor:nCaseMode + 1
   ::oGroupWrapOptions:lEnabled := ::oRadioWrap:nIndex > 1

   ::oRadioWrap:nIndex := ::IEditor:SendMsg( SCI_GETWRAPMODE ) + 1
   ::oComboVisual:nIndex := ::IEditor:SendMsg( SCI_GETWRAPVISUALFLAGS ) + 1
   ::oComboLocation:nIndex := ::IEditor:SendMsg( SCI_GETWRAPVISUALFLAGSLOCATION ) + 1
   ::oComboIndentMode:nIndex := ::IEditor:SendMsg( SCI_GETWRAPINDENTMODE ) + 1
   ::oEditStartIndent:Value := ::IEditor:SendMsg( SCI_GETWRAPSTARTINDENT )

   ::oCheckMultiSel:lChecked := ::IEditor:SendMsg( SCI_GETMULTIPLESELECTION )
   ::oCheckType:lChecked := ::IEditor:SendMsg( SCI_GETADDITIONALSELECTIONTYPING )
   ::oCheckMultiPaste:lChecked := ::IEditor:SendMsg( SCI_GETMULTIPASTE )

RETURN Nil

//------------------------------------------------------------------------------

METHOD LabelColorClick( oSender ) CLASS TFormOptions

   WITH OBJECT TChooseColorDlg():Create()
      :nColor := ::oLabelColor:nClrPane
      :lCenter := .T.
      IF :Run()
         oSender:nClrPane := :nColor
      ENDIF
   END

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button2Click( oSender ) CLASS TFormOptions

   IF ::oRadioMenuFold:nIndex < 5
      ::IEditor:lFolding := .T.
      ::IEditor:nFoldStyle := ::oRadioMenuFold:nIndex - 1
   ELSE
      ::IEditor:lFolding := .F.
   ENDIF

   ::IEditor:nViewWhiteSpace := ::oRadioMenuWS:nIndex - 1
   ::IEditor:lViewEOL := ::oCheckboxEOL:lChecked

   ::IMenu:nStyle := ::oRadioMenuMenu:nIndex - 1

   IF ::oComboCaret:nIndex == 4
      ::IEditor:nCaretStyle := CARETSTYLE_BLOCK
   ELSE
      ::IEditor:nCaretStyle := CARETSTYLE_LINE
      ::IEditor:SendMsg( SCI_SETCARETWIDTH, ::oComboCaret:nIndex )
   ENDIF
   ::IEditor:nCaretClrFore := ::oLabelColor:nClrPane

   ::IEditor:lCompleteBraces := ::oCheckboxAuto:lChecked
   ::IEditor:SendMsg( SCI_STYLESETBACK, STYLE_BRACELIGHT, ::oLabelBkColor:nClrPane )

   ::IEditor:SendMsg( SCI_SETEXTRAASCENT, Val( ::oEditAsc:Value ) )
   ::IEditor:SendMsg( SCI_SETEXTRADESCENT, Val( ::oEditDes:Value ) )

   ::IEditor:nCaseMode := ::oRadioCase:nIndex - 1

   ::IEditor:SendMsg( SCI_SETWRAPMODE, ::oRadioWrap:nIndex - 1 )
   ::IEditor:SendMsg( SCI_SETWRAPVISUALFLAGS, ::oComboVisual:nIndex - 1 )
   ::IEditor:SendMsg( SCI_SETWRAPVISUALFLAGSLOCATION, ::oComboLocation:nIndex - 1 )
   ::IEditor:SendMsg( SCI_SETWRAPINDENTMODE, ::oComboIndentMode:nIndex - 1 )
   ::IEditor:SendMsg( SCI_SETWRAPSTARTINDENT, Val( ::oEditStartIndent:Value ) )

   ::IEditor:SendMsg( SCI_SETMULTIPLESELECTION, ::oCheckMultiSel:lChecked )
   ::IEditor:SendMsg( SCI_SETADDITIONALSELECTIONTYPING, ::oCheckType:lChecked )
   ::IEditor:SendMsg( SCI_SETMULTIPASTE, ::oCheckMultiPaste:lChecked )

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button1Click( oSender ) CLASS TFormOptions

   ::Button2Click()
   ::oPlugin:SaveOptions()

RETURN Nil

//------------------------------------------------------------------------------

METHOD RadioWrapChange( oSender, nIndex, nOldIndex ) CLASS TFormOptions

   ::oGroupWrapOptions:lEnabled := nIndex > 1

RETURN Nil

//------------------------------------------------------------------------------
